#include <iostream>
#include "SDL/SDL.h"
#include "SDL/SDL_opengl.h"
#include "FreeImage.h"
#include <stdlib.h>
#include "misil.h"
#include "avion.cpp"
#include <time.h>
#include <math.h>       /* sin */
#include "FreeImage.h"
#include <sstream>
#include <fstream>
#include <vector>

#define _USE_MATH_DEFINES
#define FPS 60
#define CALIDAD 100
#define CANT_CANION 4
#define CANT_TOWER 4
#define RAD_CITY 0.4
#define CANT_CITYS 3
#define MAX_CITYS 10
#define RMISIL 1.0
#define GMISIL 1.0
#define DIFICULTAD 5
#define BMISIL 1.0
#define PUNTOS_AVION 200
#define PUNTOS_MISIL 50
#define CANT_DIGITOS_MAX_PUNTAJE 8
#define CANT_DIGITOS_VIDA_CITYS
#define CANT_HIT_AVION 4
//TEXTURES
#define CANT_TXTR 20
#define TXTR_TORRE 0
#define TXTR_MISIL 1
#define TXTR_CANION 2
#define TXTR_HOUSE 3
#define TXTR_CIELO 4
#define TXTR_PISO 5
#define TXTR_MENU 6
#define TXTR_MENU2 7

#define RADIO_MISIL 0.2
#define RADIO_AVION 0.3

#define POR_HIT 25

using namespace std;

struct vertice {
    float x, y, z;
};

struct textura {
    float x, y;
};

struct Poligono {
	vector<int> vertices;
	vector<int> texturas;
	vector<int> normales;
};

Poligono procesarPoligono(string linea);
vertice procesarVertice(string linea, float escalamiento);
vertice procesarNormal(string linea);
textura procesarTextura(string linea);
void dibujarObjeto(vector<Poligono> pols, vector<vertice> vertices, vector<textura> texturado, vector<vertice> normales);
vector<Poligono> cargarObjeto(const char* filename, float escalamiento,
                              vector<vertice> &vertices, vector<textura> &texturas, vector<vertice> &normales);



////PARTICULAS


////PARTICULAS END





void printUnNum(float aspectx, float aspecty, float escala, float offsetx, float offsety, float offsetz, char num){

    glBegin(GL_QUADS);
        if(num == '0'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num == '1'){
            glVertex3f((0.8*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num == '2'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num == '3'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num == '4'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num == '5'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num == '6'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num == '7'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num == '8'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num == '9'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num=='c'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.2*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num=='i'){
            glVertex3f((0.4*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.6*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.6*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.4*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num=='t'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.8*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.4*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.6*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.6*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.4*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
        if(num=='y'){
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.2*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.4*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.8*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((1.0*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.8*escala+offsetx)*aspectx,(1.0*escala+offsety)*aspecty,0.0*escala+offsetz);

            glVertex3f((0.4*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.6*escala+offsetx)*aspectx,(0.0*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.6*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
            glVertex3f((0.4*escala+offsetx)*aspectx,(0.6*escala+offsety)*aspecty,0.0*escala+offsetz);
        }
    glEnd();
}

void printNumers(float aspectx, float aspecty, float escala, float offsetx, float offsety, float offsetz, int &numero, bool esvida){
        char buffer[CANT_DIGITOS_MAX_PUNTAJE];
        char print[CANT_DIGITOS_MAX_PUNTAJE];
        itoa(numero,buffer,10);
        float interleaving = escala*0.2;
        int tam = strlen(buffer);
        int diff = CANT_DIGITOS_MAX_PUNTAJE - tam;
        if(numero < pow(10,CANT_DIGITOS_MAX_PUNTAJE)){
            for(int j=0;j<CANT_DIGITOS_MAX_PUNTAJE;j++){
                if(diff>j){
                    print[j]='0';
                }
                else{
                    print[j]=buffer[(j-diff)];
                }
            }
            if(not(esvida)){
                for(int i=0;i<CANT_DIGITOS_MAX_PUNTAJE;i++){
                    printUnNum(aspectx,aspecty,escala,offsetx,offsety,offsetz,print[i]);
                    offsetx += (escala+10+interleaving)*aspectx;
                }
            }
            else{
                for(int i=0;i<3;i++){
                    printUnNum(aspectx,aspecty,escala,offsetx,offsety,offsetz,print[CANT_DIGITOS_MAX_PUNTAJE-3+i]);
                    offsetx += (escala+10+interleaving)*aspectx;
                }
            }
        }
        else{
            numero = numero - pow(10,CANT_DIGITOS_MAX_PUNTAJE);
        }
}

void printCitys(float aspectx, float aspecty, float escala, float offsetx, float offsety, float offsetz, int vidaCitys[]){
        float interleaving = escala*0.2;
        float originaloffsetx = offsetx;
        for(int i=0;i<CANT_CITYS;i++){
            glColor3f(0.0,0.0,1.0);
            printUnNum(aspectx,aspecty,escala,offsetx,offsety,offsetz,'c');
            offsetx += (escala)*aspectx;
            printUnNum(aspectx,aspecty,escala,offsetx,offsety,offsetz,'i');
            offsetx += (escala)*aspectx;
            printUnNum(aspectx,aspecty,escala,offsetx,offsety,offsetz,'t');
            offsetx += (escala+4+interleaving)*aspectx;
            printUnNum(aspectx,aspecty,escala,offsetx,offsety,offsetz,'y');
            offsetx += (escala+10+interleaving)*aspectx;
            char buff[1];
            int numcity = i+1;
            itoa(numcity,buff,10);
            printUnNum(aspectx,aspecty,escala,offsetx,offsety,offsetz,buff[0]);
            offsetx += (escala+10+interleaving)*aspectx;
            float interleaving = escala*0.2;
            if(vidaCitys[i]>50){
                glColor3d(0,1,0);
            }
            else if(vidaCitys[i]>25){
                glColor3d(1,1,0);
            }
            else if(vidaCitys[i]>0){
                glColor3d(1,0,0);
            }else{
                glColor3d(1,1,1);
            }
            if(vidaCitys[i]>=0){
                printNumers(aspectx,aspecty,escala,offsetx,offsety,offsetz,vidaCitys[i],true);
                offsety -= (escala+ interleaving)*aspecty;
            }
            else{
                int vida =0;
                printNumers(aspectx,aspecty,escala,offsetx,offsety,offsetz,vida,true);
                offsety -= (escala+ interleaving)*aspecty;
            }
            offsetx = originaloffsetx;
        }
}


void actualizarCam(float &x,float &y, float &z, float x_angle, float y_angle,float radius){
    z = -1.8 + cos(y_angle*M_PI/180) * cos(x_angle*M_PI/180) * radius;
    x = 0.0 + sin(y_angle*M_PI/180) * cos(x_angle*M_PI/180) * radius;
    y = 0.9 + sin(x_angle*M_PI/180) * radius;
}


void drawCircle(int numSteps, float hl, float radius){
    glBegin(GL_POLYGON);
    float texture_patter_coef = 0.05;//0.3 factro de ajuste textura cuanto mas chico mas estirada
        /*for(int ii = 0; ii < numSteps; ii++)
        {
            glNormal3f(0,0, hl);
            float theta = 2.0f * M_PI * float(ii) / float(numSteps);//get the current angle
            float x = radius * cosf(theta);//calculate the x component
            float y = radius * sinf(theta);//calculate the y component
            glTexCoord2f(0.2*radius,ii*2*radius*M_PI/numSteps);
            glVertex3f(x + 0, y + 0,hl);//output vertex
        }*/
         float angle, radian, x, y;       // values needed by drawCircleOutline

         for (angle=0.0; angle<360.0; angle+=2.0)
    {
        radian = angle * (3.1416/180.0f);

        x = (float)cos(radian) * radius;//  + c.pos.x;
        y = (float)sin(radian) * radius;//  + c.pos.y;

        glTexCoord2f(texture_patter_coef*x, texture_patter_coef*y);
        glVertex2f(x, y);
    }
    glEnd();
}



void drawAro(int numSteps,float * arrX_1, float* arrX_2, float * arrY_1, float* arrY_2, float hl, float r){
        glBegin(GL_QUAD_STRIP);
        int j;
        for(j = 0; j <= numSteps; j++){
              glNormal3f(0,0, -hl);
              glTexCoord2f(0,j*2*r*M_PI/numSteps);
              glVertex3f(arrX_1[j],arrY_1[j],-hl);
              glNormal3f(0,0, -hl);
              glTexCoord2f(0.2*r,j*2*r*M_PI/numSteps);
              glVertex3f(arrX_2[j],arrY_2[j],-hl);
        }
        glEnd();
}

void drawCylinder(int numSteps,float radius, float hl,float* arrX_1,float* arrY_1){
    float a = 0.0f;
    float step = (2*M_PI) / (float)numSteps;


    glBegin(GL_TRIANGLE_STRIP);
    for (int i = 0; i <= numSteps; i++)
    {
        float x = cos(a) * radius;
        float y = sin(a) * radius;
        arrX_1[i]=x;
        arrY_1[i]=y;
        glNormal3f(x/radius,y/radius,0);
        glTexCoord2f(0,i*2*radius*M_PI/numSteps);
        glVertex3f(x,y,-hl);
        glNormal3f(x/radius,y/radius, 0);
        glTexCoord2f(2*hl,i*2*radius*M_PI/numSteps);
        glVertex3f(x,y, hl);
        a += step;
    }
    glEnd();
}


void drawHalfSphere(int lats, int longs, GLfloat r) {
   int i, j;
    int halfLats = lats / 2;
    for(i = 0; i <= halfLats; i++)
    {
        double lat0 = M_PI * (-0.5 + (double) (i - 1) / lats);
        double z0 = sin(lat0);
        double zr0 = cos(lat0);

        double lat1 = M_PI * (-0.5 + (double) i / lats);
        double z1 = sin(lat1);
        double zr1 = cos(lat1);

        glBegin(GL_QUAD_STRIP);
        for(j = 0; j <= longs; j++)
        {
            double lng = 2 * M_PI * (double) (j - 1) / longs;
            double x = cos(lng);
            double y = sin(lng);

            double s1, s2, t;
            s1 = ((double) i) / halfLats;
            s2 = ((double) i + 1) / halfLats;
            t = ((double) j) / longs;

            glTexCoord2d(s1, t);
            glNormal3d(x * zr0, y * zr0, z0);
            glVertex3d(r*x * zr0, r*y * zr0, r*z0);

            glTexCoord2d(s2, t);
            glNormal3d(x * zr1, y * zr1, z1);
            glVertex3d(r*x * zr1,r* y * zr1, r*z1);
        }
        glEnd();
    }
 }

void tower(float posx, float posy, float posz, float radius, float length, int numSteps) {
   glPushMatrix();

    float hl = length * 0.5f;

    float angulo=90;
    float arrX_1[numSteps+1];
    float arrY_1[numSteps+1];
    float arrX_2[numSteps+1];
    float arrY_2[numSteps+1];

    //glTranslatef(0.0,0.0,hl);
    glTranslatef(0.0,0.0,-hl);
    glTranslatef(posx,posy,posz);//MIO
    glRotatef(angulo,0.0,0.0,1.0);


    drawCylinder(numSteps,radius,hl,arrX_2,arrY_2);//cilindro grande
    radius=0.15;
    drawCylinder(numSteps,radius,hl,arrX_1,arrY_1);//cilindro chico
    drawAro(numSteps,arrX_1,arrX_2,arrY_1,arrY_2,hl,radius);//aro entre cilindros
    glPopMatrix();
 }

void city(float posx, float posy, float posz, float radius, int numSteps){
     glPushMatrix();

      //glRotatef(-90,1.0,0.0,0.0);
      //glTranslatef(0.0,0.0,hl);
      glTranslatef(posx,posy,posz);//MIO
      //drawCircle(numSteps,0.0,radius);//tapa de la semi-esfera
      drawHalfSphere(numSteps,numSteps,radius);
     glPopMatrix();
 }

void cielitoLindo(float posx, float posy, float posz, float radius, int numSteps){
     glPushMatrix();

      //glRotatef(-90,1.0,0.0,0.0);
      //glTranslatef(0.0,0.0,hl);
      glTranslatef(posx,posy,posz);//MIO
      //drawCircle(numSteps,0.0,radius);//tapa de la semi-esfera
      drawHalfSphere(numSteps,numSteps,radius);
     glPopMatrix();
}
void ground(float posx, float posy, float posz, float radius, int numSteps){
     glPushMatrix();

      //glRotatef(-90,1.0,0.0,0.0);
      //glTranslatef(0.0,0.0,hl);
      glTranslatef(posx,posy,posz);//MIO
      drawCircle(numSteps,0.0,radius);//tapa de la semi-esfera
      //drawHalfSphere(numSteps,numSteps,radius);
     glPopMatrix();

    /*glColor3f(0.039f, 0.341f, 0.078f);
    glNormal3f(1.0f, 1.0f, 1.0f);
    glBegin(GL_QUADS);
      glVertex3f(-15.0f, -15.0f, 0.0f);
      glVertex3f(-15.0f,  15.0f, 0.0f);
      glVertex3f( 15.0f,  15.0f, 0.0f);
      glVertex3f( 15.0f, -15.0f, 0.0f);
    glEnd();*/
}


void canion(float posx, float posy, float posz, float crad, float angulo, int numSteps){
     glPushMatrix();
      float length=crad*2.0;
    float hl = length * 0.5f;
    float radius=crad*0.3;
    float arrX_1[numSteps+1];
    float arrY_1[numSteps+1];
    float arrX_2[numSteps+1];
    float arrY_2[numSteps+1];

    //glTranslatef(0.0,0.0,hl);
    glRotatef(angulo,posx,posy,posz);
    glTranslatef(0.0,0.0,-hl);
    glTranslatef(posx,posy,posz);//MIO
    drawCylinder(numSteps,radius,hl,arrX_2,arrY_2);//cilindro grande
    radius=1.1*crad*0.3;
    drawCylinder(numSteps,radius,hl,arrX_1,arrY_1);//cilindro chico
    drawAro(numSteps,arrX_1,arrX_2,arrY_1,arrY_2,hl,radius);//aro entre cilindros
   glPopMatrix();


     glPushMatrix();
     radius=crad;
      //glRotatef(-90,1.0,0.0,0.0);
      //glTranslatef(0.0,0.0,hl);

      glTranslatef(posx,posy,posz);//MIO
      drawCircle(numSteps,0.0,radius);//tapa de la semi-esfera
      drawHalfSphere(numSteps,numSteps,radius);
     glPopMatrix();
 }

void misil(float altura, float radioinferior, float radiosuperior, float Ox, float Oy, float Oz,Misil* buffmisiles,int &cantmis, int &cantvivos){
     buffmisiles[cantmis] = getMisil(altura,radioinferior,radiosuperior,Ox,Oy,Oz,DIFICULTAD);
     cantvivos++;
}

void avion(float altura, float radioinferior, float radiosuperior, float Ox, float Oy, float Oz,Avion &plane,int &canthitrest){
    plane=getAvion(altura,radioinferior,radiosuperior,Ox,Oy,Oz,canthitrest,DIFICULTAD);
}

void explosion(int i, Misil * buffmisiles){
    if(buffmisiles[i].explosionesrestantes>=0){
       glPushMatrix();
            glColor3f(1.0,0.0,0.0);
            float radius=0.15/buffmisiles[i].explosionesrestantes;
            buffmisiles[i].explosionesrestantes--;
            glTranslatef(buffmisiles[i].xActual,buffmisiles[i].yActual,buffmisiles[i].zActual+RADIO_MISIL);
            drawHalfSphere(20,20,radius);
            glRotatef(180,0.0,0.0,0.0);
            drawHalfSphere(20,20,radius);
            glColor3f(RMISIL,GMISIL,BMISIL);
        glPopMatrix();
    }
    else{
        buffmisiles[i].explotando=false;
    }
}
void explosionav(Avion &av){
    if(av.explosionesrestantes>=0){
       glPushMatrix();
            glColor3f(1.0,0.0,0.0);
            float radius=0.15/av.explosionesrestantes;
            av.explosionesrestantes--;
            glTranslatef(av.xActual,av.yActual,av.zActual);
            drawHalfSphere(20,20,radius);
            glRotatef(180,0.0,0.0,0.0);
            drawHalfSphere(20,20,radius);
            glColor3f(RMISIL,GMISIL,BMISIL);
        glPopMatrix();
    }
    else{
        av.explotando=false;
    }
}



void calcularmisiles(Misil* buffmisiles,int &cantmis,int &cantvivos,float radiociudad,float coordCitys[][3],int vidaCitys[]){
    for(int i=0;i<cantmis;i++){
        if(buffmisiles[i].vivo){
            if(buffmisiles[i].zActual <= 0){
                float xfin = buffmisiles[i].xFinal;
                float yfin = buffmisiles[i].yFinal;
                float zfin = buffmisiles[i].zFinal;
                float xini = buffmisiles[i].xInicial;
                float yini = buffmisiles[i].yInicial;
                float zini = buffmisiles[i].zInicial;
                float xaux = xfin - xini;
                float yaux = yfin - yini;
                float zaux = zfin - zini;
                double normaVec= sqrt(pow(xaux,2)+pow(yaux,2)+pow(zaux,2));
                xaux = (xaux/normaVec);
                yaux = (yaux/normaVec);
                zaux = (zaux/normaVec);
                clock_t timeact = clock();
                float tim = float(timeact - buffmisiles[i].t0)/CLOCKS_PER_SEC;
                buffmisiles[i].xActual = buffmisiles[i].xInicial + xaux*buffmisiles[i].velocx*tim;
                buffmisiles[i].yActual = buffmisiles[i].yInicial + yaux*buffmisiles[i].velocy*tim;
                buffmisiles[i].zActual = buffmisiles[i].zInicial + zaux*buffmisiles[i].velocz*tim;
                double distActual[CANT_CITYS];
                //calculo distancias desde los misiles a cada una de las ciudades
                for(int j=0;j<CANT_CITYS;j++){

                    distActual[j]=sqrt(pow(buffmisiles[i].xActual-coordCitys[j][0],2)+
                                       pow(buffmisiles[i].yActual-coordCitys[j][1],2)+
                                       pow(buffmisiles[i].zActual-coordCitys[j][2],2));
                    if(distActual[j]<=RAD_CITY + RADIO_MISIL){
                        buffmisiles[i].vivo = false;
                        cantvivos--;
                        buffmisiles[i].explotando = true;
                        vidaCitys[j] -= POR_HIT;
                    }
                }

            }
            else{
                buffmisiles[i].vivo = false;
                cantvivos--;
            }
        }
    }

}

void calcularavion(Avion &avion, int &canthitrest, bool &hayavion){
        float tim = float(clock() - avion.t0)/CLOCKS_PER_SEC;
        if(avion.vivo){
            if(tim<10){
                float xfin = avion.xFinal;
                float yfin = avion.yFinal;
                float zfin = avion.zFinal;
                float xini = avion.xInicial;
                float yini = avion.yInicial;
                float zini = avion.zInicial;
                float xaux = xfin - xini;
                float yaux = yfin - yini;
                float zaux = zfin - zini;
                double normaVec= sqrt(pow(xaux,2)+pow(yaux,2)+pow(zaux,2));
                xaux = (xaux/normaVec);
                yaux = (yaux/normaVec);
                zaux = (zaux/normaVec);
                clock_t timeact = clock();
                float tim = float(timeact - avion.t0)/CLOCKS_PER_SEC;
                avion.xActual = avion.xInicial + xaux*avion.velocx*tim;
                avion.yActual = avion.yInicial + yaux*avion.velocy*tim;
                avion.zActual = avion.zInicial + zaux*avion.velocz*tim;
            }
            else{
                avion.vivo = false;
                canthitrest=0;
                hayavion=false;
            }
        }

}

void drawestela(int i, Misil * buffmisiles){
    glPushMatrix();
        glBegin(GL_LINES);
                glVertex3f(buffmisiles[i].xActual,buffmisiles[i].yActual,buffmisiles[i].zActual);
                glVertex3f(buffmisiles[i].xInicial,buffmisiles[i].yInicial,buffmisiles[i].zInicial);
        glEnd();
    glPopMatrix();
}

void drawmisiles(int numSteps, Misil * buffmisiles,int &cantmisiles,
                 vector<vertice> vMisil, vector<textura> tMisil, vector<vertice> nMisil, vector<Poligono> oMisil){
    for(int i=0;i<cantmisiles;i++){
            if(buffmisiles[i].vivo){
                glPushMatrix();
                    glTranslatef(buffmisiles[i].xActual,buffmisiles[i].yActual,buffmisiles[i].zActual);
                    dibujarObjeto(oMisil,vMisil,tMisil,nMisil);
                    glRotatef(180,0.0,0.0,0.1);
                    dibujarObjeto(oMisil,vMisil,tMisil,nMisil);
                glPopMatrix();
                drawestela(i,buffmisiles);
                glPushMatrix();
                    glTranslatef(buffmisiles[i].xFinal,buffmisiles[i].yFinal,buffmisiles[i].zFinal);
                    drawHalfSphere(numSteps,numSteps,0.045);
                glPopMatrix();
            }
            else if(buffmisiles[i].explotando){
                    explosion(i,buffmisiles);
            }
    }
}

void drawavion(int numSteps, Avion &avion,int &canthitrest,bool &hit, vector<vertice> vAvion,
               vector<textura> tAvion, vector<vertice> nAvion, vector<Poligono> oAvion){
            if(avion.vivo){
                glPushMatrix();
                    float radius=0.09;
                    if(hit){
                        glColor3f(1.0,0.0,0.0);
                        Sleep(10);
                    }
                    else{
                        glColor3f(0.0,0.1,1.0);
                    }
                    glRotatef(90,0.0,0.1,0.0);
                    glTranslatef(avion.xActual,avion.yActual,avion.zActual);
                    dibujarObjeto(oAvion,vAvion,tAvion,nAvion);
                    hit=false;
                glPopMatrix();
                //drawestela(i,buffmisiles);
            }
            else if(avion.explotando){
                    explosionav(avion);
            }

}

void hitMisil(int i, Misil * buffmisiles, int &cantvivos, int &puntaje, bool usrkill){
    buffmisiles[i].vivo = false;
    buffmisiles[i].explotando = true;
    cantvivos--;
    if (usrkill){
       puntaje += PUNTOS_MISIL;
       }
}

void hitAvion(Avion &avion, int &canthitrest, int &puntaje){
    if(canthitrest>0){
        canthitrest--;
    }
    else{
        puntaje += PUNTOS_AVION;
        avion.vivo=false;
        avion.explotando=true;
    }
}

bool isHit(float x1, float y1, float z1, float x2, float y2, float z2, float x3, float y3, float z3, float radio ){
        double r = radio;
        double dx = (x2*100 - x1*100)/100;
        double dy = (y2*100 - y1*100)/100;
        double dz = (z2*100 - z1*100)/100;

        double a = dx*dx + dy*dy + dz*dz;
        double b = 2.0 * (dx * (x1 - x3) + dy * (y1 - y3) + dz * (z1 - z3));
        double c = x3*x3 + y3*y3 + z3*z3 + x1*x1 + y1*y1 + z1*z1 - 2.0 * (x3*x1 + y3*y1 + z3*z1) - r*r;

        double test = b*b - 4.0*a*c;
        if (test >= 0.0) {
          return true;
        }
        else{
            return false;
        }
}

void dibujartorres(float coordcannon[], float altura_tower[], float angulo_canion[]){
    for(int h=0;h<CANT_CANION;h++){
        tower(coordcannon[h*2], coordcannon[h*2+1], 0.0,0.1,altura_tower[2],CALIDAD);
        //canion(coordcannon[h*2], coordcannon[h*2+1], -altura_tower[1],0.1,angulo_canion[1],CALIDAD/5);
    }
}

void dibujarcaniones(float coordcannon[], float altura_tower[], float angulo_canion[]){
    for(int h=0;h<CANT_CANION;h++){
        //tower(coordcannon[h*2], coordcannon[h*2+1], 0.0,0.1,altura_tower[2],CALIDAD);
        canion(coordcannon[h*2], coordcannon[h*2+1], -altura_tower[1],0.1,angulo_canion[1],CALIDAD/5);
    }
}

void dibujarciudades(float coordCitys[][CANT_CITYS], int vidaCitys[]){
    for(int i=0;i<CANT_CITYS;i++){
        if(vidaCitys[i]>0)
            city(coordCitys[i][0], coordCitys[i][1], coordCitys[i][2],RAD_CITY,CALIDAD);
    }
}

void calcularLookAt(int nro_canion, float comp, float coordcannon[], float x, float y, float z, float lz){
        if(nro_canion==1){
            comp= 1.5+lz*0.05;
            if(comp>=coordcannon[nro_canion*2 +1]){
                    gluLookAt(x,y,-z,
                      1,comp,-1.0125,
                      0,1,0);
                }else{
                    gluLookAt(x,y,-z,
                      1,coordcannon[nro_canion*2+1],-1.0125,
                      0,1,0);
                }

          }else if(nro_canion==2){
              comp= x-lz*0.025;
              if(comp<coordcannon[nro_canion*2]+1){
                     gluLookAt(x,y,-z,
                        comp,-y,-z/2,
                        -1,0,0);
              }
              else{
                     gluLookAt(x,y,-z,
                        coordcannon[nro_canion*2]+1,-y,-z/2,
                        -1,0,0);
              }
          }else if(nro_canion==3){
                comp= 0-1.5-lz*0.05;
                if(comp<coordcannon[nro_canion*2]){
                    gluLookAt(x,y,-z,
                            comp,-1.0,-z/2,
                            -1,0,0);
                }
                else{
                    gluLookAt(x,y,-z,
                            coordcannon[nro_canion*2],-1.0,-z/2,
                            -1,0,0);
                }
          }else{
                comp = -y-lz*0.4-5;
                if(comp<coordcannon[nro_canion*2 +1]-1){
                        gluLookAt(x,y,-z,
                            x,comp,-z/2,
                            0,-1,0);
                }
                else{
                        gluLookAt(x,y,-z,
                            x,coordcannon[nro_canion*2+1]-1,-z/2,
                            0,-1,0);
                }

          }

}
void generarMisiles(clock_t &ultimogenerado, float coordCitys[][3], Misil * buffmisiles, int &cantmisiles,float altura, int &cantvivos, int vidaCitys[]){
    clock_t timec = clock();
    float diff = float (timec - ultimogenerado)/CLOCKS_PER_SEC;
    if(diff > 10/DIFICULTAD){
        srand(time(NULL)+rand());
        float random = rand()*4.0/RAND_MAX - 1;
        for(int i=0;i<CANT_CITYS;i++){
            if(vidaCitys[i]>0){
                if(random<i && random>=(i-1)){
                    misil(altura,RAD_CITY,RAD_CITY*2.5,coordCitys[i][0],
                    coordCitys[i][1],coordCitys[i][2],buffmisiles,cantmisiles,cantvivos);
                    cantmisiles++;
                    ultimogenerado = timec;
                }
            }
        }

    }
}

void generarAviones(clock_t &ultimogenerado, float altura, Avion &av, float radio, int &canthitrest, float coordavion[], bool &hayavion){
    clock_t timec = clock();
    float diff = float (timec - ultimogenerado)/CLOCKS_PER_SEC;
    if(diff > (10/DIFICULTAD)*15){
        if(not(hayavion)){
                srand(time(NULL)+rand());
                float random = rand()*4.0/RAND_MAX - 3;
                float sign1 = random/abs(random);
                float random2 = rand()*4.0/RAND_MAX - 3;
                float sign2 = random2/abs(random2);
                canthitrest=CANT_HIT_AVION;
                avion(altura,radio,radio,sign1*coordavion[0],coordavion[1],coordavion[2],av,canthitrest);
                hayavion=true;
                ultimogenerado = clock();
        }
    }
}



float x,y,z,x11,y11,z11;
Misil buffmisiles[100];
float coordCitys[MAX_CITYS][CANT_CITYS];
int vidaCitys[CANT_CITYS];
int cantmisiles=0;
int cantvivos=0;
clock_t ultimogenerado, ultimoavgenerado;
float coordavion[3];
int canthitrest=0;
Avion av;
bool hayavion=false;
int puntaje;

void loadTexture(char * archivo, GLuint textura[CANT_TXTR], int i){
    FREE_IMAGE_FORMAT fif = FreeImage_GetFIFFromFilename(archivo);
    FIBITMAP* bitmap = FreeImage_Load(fif, archivo);
    bitmap = FreeImage_ConvertTo24Bits(bitmap);

    int w = FreeImage_GetWidth(bitmap);
    int h = FreeImage_GetHeight(bitmap);

    void* datos = FreeImage_GetBits(bitmap);

    glBindTexture(GL_TEXTURE_2D, textura[i]);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, w, h, 0, GL_BGR, GL_UNSIGNED_BYTE, datos);

    delete datos;
};
void loadTexture2(char * archivo, GLuint textura[CANT_TXTR], int i){
    FREE_IMAGE_FORMAT fif = FreeImage_GetFIFFromFilename(archivo);
    FIBITMAP* bitmap = FreeImage_Load(fif, archivo);
    bitmap = FreeImage_ConvertTo24Bits(bitmap);

    int w = FreeImage_GetWidth(bitmap);
    int h = FreeImage_GetHeight(bitmap);

    void* datos = FreeImage_GetBits(bitmap);

    glBindTexture(GL_TEXTURE_2D, textura[i]);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
    //glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    //glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    //glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    //glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    //glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, w, h, 0, GL_BGR, GL_UNSIGNED_BYTE, datos);

    delete datos;
};

//////////// MENU
/*void menu(GL gl) {
        gl.glBegin(GL.GL_QUADS);
        gl.glColor4f(1.0f, 0.0f, 0.0f, 0.0f);
        gl.glTexCoord2f(0.0f, 0.0f);
        gl.glVertex3d(0, 0, 0);
        gl.glTexCoord2f(0.0f, 1.0f);
        gl.glVertex3d(0, 1, 0);
        gl.glTexCoord2f(1.0f, 1.0f);
        gl.glVertex3d(1, 1, 0);
        gl.glTexCoord2f(1.0f, 0.0f);
        gl.glVertex3d(1, 0, 0);
        gl.glEnd();
    }*/

/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees
   and is provided without guarantee or warrantee expressed or
   implied. This program is -not- in the public domain. */
/*
#include <string.h>
#include <stdio.h>
#include <stdarg.h>
#include <GL/glut.h>

void
bitmap_output(int x, int y, char *string, void *font)
{
  int len, i;

  glRasterPos2f(x, y);
  len = (int) strlen(string);
  for (i = 0; i < len; i++) {
    glutBitmapCharacter(font, string[i]);
  }
}

void
stroke_output(GLfloat x, GLfloat y, char *format,...)
{
  va_list args;
  char buffer[200], *p;

  va_start(args, format);
  vsprintf(buffer, format, args);
  va_end(args);
  glPushMatrix();
  glTranslatef(x, y, 0);
  glScalef(0.005, 0.005, 0.005);
  for (p = buffer; *p; p++)
    glutStrokeCharacter(GLUT_STROKE_ROMAN, *p);
  glPopMatrix();
}

void
display(void)
{
  glClear(GL_COLOR_BUFFER_BIT);
  bitmap_output(40, 35, "This is written in a GLUT bitmap font.",
    GLUT_BITMAP_TIMES_ROMAN_24);
  bitmap_output(30, 210, "More bitmap text is a fixed 9 by 15 font.",
    GLUT_BITMAP_9_BY_15);
  bitmap_output(70, 240, "                Helvetica is yet another bitmap font.",
    GLUT_BITMAP_HELVETICA_18);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  gluPerspective(40.0, 1.0, 0.1, 20.0);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  gluLookAt(0.0, 0.0, 4.0,  //eye is at (0,0,30)
    0.0, 0.0, 0.0,       //center is at (0,0,0)
    0.0, 1.0, 0.);      //up is in postivie Y direction
  glPushMatrix();
  glTranslatef(0, 0, -4);
  glRotatef(50, 0, 1, 0);
  stroke_output(-2.5, 1.1, "  This is written in a");
  stroke_output(-2.5, 0, " GLUT stroke font.");
  stroke_output(-2.5, -1.1, "using 3D perspective.");
  glPopMatrix();
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glMatrixMode(GL_MODELVIEW);
  glFlush();
}

void
reshape(int w, int h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, w, 0, h);
  glScalef(1, -1, 1);
  glTranslatef(0, -h, 0);
  glMatrixMode(GL_MODELVIEW);
}
*/
/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees
   and is provided without guarantee or warrantee expressed or
   implied. This program is -not- in the public domain. */
/*
#include <string.h>
#include <GL/glut.h>

void *font = GLUT_STROKE_ROMAN;
void *fonts[] =
{GLUT_STROKE_ROMAN, GLUT_STROKE_MONO_ROMAN};
char defaultMessage[] = "GLUT means OpenGL.";
char *message = defaultMessage;

int angle = 0;

void
selectFont(int newfont)
{
  font = fonts[newfont];
  glutPostRedisplay();
}

void
selectMessage(int msg)
{
  switch (msg) {
  case 1:
    message = "abcdefghijklmnop";
    break;
  case 2:
    message = "ABCDEFGHIJKLMNOP";
    break;
  }
}

void
tick(void)
{
  angle -= 2;
  glutPostRedisplay();
}

void
display(void)
{
  int len, i;

  glClear(GL_COLOR_BUFFER_BIT);
  glPushMatrix();
  glRotatef(angle, 0.0, 0.0, 1.0);
  glTranslatef(-750, 0, 0);
  len = (int) strlen(message);
  for (i = 0; i < len; i++) {
    glutStrokeCharacter(font, message[i]);
  }
  glPopMatrix();
  glutSwapBuffers();
}
*/

void menu(){// Draw ground
    glColor3f(0.039f, 0.341f, 0.078f);
    glNormal3f(1.0f, 1.0f, 1.0f);
    glBegin(GL_QUADS);
//PANTALLA (x,y)
//     ----> x
//     |
//     |
//     V y
//(-1, -1)  (-1, 1)
//( 1, -1)  ( 1, 1)

//TEXTURA
//     ^ y
//     |
//     |
//     ----> x
// (0,1) (1,1)
// (0,0) (1,0)


       glVertex3f(-1.25f,  0.95f,  -2.2f);
        glTexCoord2f(1.f, 1.0f);
        //glVertex2f(3.0f, 3.0f);
        glVertex3f(1.25f, 0.95f,  -2.2f);
        glTexCoord2f(1.f, 0.0f);
        //glVertex2f(-3.0f, 3.0f);
        glVertex3f(1.25f, -1.0f, -2.2f);
        glTexCoord2f(0.0f, 0.0f);
        //glVertex2f(-3.0f, -3.0f);
        glVertex3f(-1.25f,  -1.0f, -2.2f);
        glTexCoord2f(0.0f, 1.0f);
        //glVertex2f(-3.0f, -3.0f);



    glEnd();

        /*glVertex2f(0.0f, 0.0f);
        glTexCoord2f(0.0f, 0.0f);
        //glVertex2f(-3.0f, -3.0f);
        glVertex2f(0, 640.0f);
        glTexCoord2f(0, 640.0f);
        //glVertex2f(-3.0f, -3.0f);

        glVertex2f(480.0f,  640.0f);
        glTexCoord2f(480.0f,  640.0f);
        //glVertex2f(-3.0f, 3.0f);

        glVertex2f(480.0f,  0.0f);
        glTexCoord2f(480.0f, 0.0f);*/

}
//////////// MENU END

///////PARTICULAS
/*
 * Title: Simple OpenGL Fireworks with Trails
 * Author: r3dux
 * Date: 31/10/2010
 */

// Uncomment for Win32 systems
// Search for and include the opengl32 and glu (GL-Utility) libraries
//#pragma comment(lib, "opengl32.lib")
//#pragma comment(lib, "glu32.lib")

#include <iostream>
#include <ctime>
#include <time.h>		// Needed to use random numbers
//#include <windows.h>	// *** IMPORTANT: Uncomment for Win32 systems - This must come -BEFORE- gl.h in the include list! ***
#include <GL/gl.h>		// OpenGL headers
#include <SDL/SDL.h>		// Simple DirectMedia Layer headers
using namespace std;

// Define our initial screen width, height, and colour depth
GLint SCREEN_WIDTH  = 800;
GLint SCREEN_HEIGHT = 600;
GLint SCREEN_BPP    =  16;

// Define our SDL surface
SDL_Surface *surface;

const int FIREWORKS = 15;           // Number of fireworks
const int FIREWORK_PARTICLES = 50;  // Number of particles per firework

class Firework
{
	public:
		GLfloat x[FIREWORK_PARTICLES];
		GLfloat y[FIREWORK_PARTICLES];
		GLfloat xSpeed[FIREWORK_PARTICLES];
		GLfloat ySpeed[FIREWORK_PARTICLES];

		GLfloat red;
		GLfloat blue;
		GLfloat green;
		GLfloat alpha;

		GLint framesUntilLaunch;

		GLfloat particleSize;
		GLboolean hasExploded;

		static const GLfloat baselineYSpeed;
		static const GLfloat maxYSpeed;

		static const GLfloat GRAVITY;

		Firework(); // Constructor declaration
		void initialise();
		void move();
		void explode();
};

const GLfloat Firework::GRAVITY = 0.05f;
const GLfloat Firework::baselineYSpeed = -4.0f;
const GLfloat Firework::maxYSpeed = -4.0f;

// Constructor implementation
Firework::Firework()
{
	initialise();
}

void Firework::initialise()
{
    // Pick an initial x location and  random x/y speeds
    float xLoc = (rand() / (float)RAND_MAX) * SCREEN_WIDTH;
    float xSpeedVal = -2 + (rand() / (float)RAND_MAX) * 4.0f;
    float ySpeedVal = baselineYSpeed + ((float)rand() / (float)RAND_MAX) * maxYSpeed;

    // Set initial x/y location and speeds
    for (int loop = 0; loop < FIREWORK_PARTICLES; loop++)
    {
        x[loop] = xLoc;
        y[loop] = SCREEN_HEIGHT + 10.0f; // Push the particle location down off the bottom of the screen
        xSpeed[loop] = xSpeedVal;
        ySpeed[loop] = ySpeedVal;
    }

    // Assign a random colour and full alpha (i.e. particle is completely opaque)
    red   = (rand() / (float)RAND_MAX);
    green = (rand() / (float)RAND_MAX);
    blue  = (rand() / (float)RAND_MAX);
    alpha = 1.0f;

    // Firework will launch after a random amount of frames between 0 and 400
    framesUntilLaunch = ((int)rand() % 400);

    // Size of the particle (as thrown to glPointSize) - range is 1.0f to 4.0f
    particleSize = 1.0f + ((float)rand() / (float)RAND_MAX) * 3.0f;

    // Flag to keep trackof whether the firework has exploded or not
    hasExploded = false;

    cout << "Initialised a firework." << endl;
}

void Firework::move()
{
    for (int loop = 0; loop < FIREWORK_PARTICLES; loop++)
    {
        // Once the firework is ready to launch start moving the particles
        if (framesUntilLaunch <= 0)
        {
            x[loop] += xSpeed[loop];

            y[loop] += ySpeed[loop];

            ySpeed[loop] += Firework::GRAVITY;
        }
    }
    framesUntilLaunch--;

    // Once a fireworks speed turns positive (i.e. at top of arc) - blow it up!
    if (ySpeed[0] > 0.0f)
    {
        for (int loop2 = 0; loop2 < FIREWORK_PARTICLES; loop2++)
        {
            // Set a random x and y speed beteen -4 and + 4
            xSpeed[loop2] = -4 + (rand() / (float)RAND_MAX) * 8;
            ySpeed[loop2] = -4 + (rand() / (float)RAND_MAX) * 8;
        }

        cout << "Boom!" << endl;
        hasExploded = true;
    }
}

void Firework::explode()
{
    for (int loop = 0; loop < FIREWORK_PARTICLES; loop++)
    {
        // Dampen the horizontal speed by 1% per frame
        xSpeed[loop] *= 0.99;

        // Move the particle
        x[loop] += xSpeed[loop];
        y[loop] += ySpeed[loop];

        // Apply gravity to the particle's speed
        ySpeed[loop] += Firework::GRAVITY;
    }

    // Fade out the particles (alpha is stored per firework, not per particle)
    if (alpha > 0.0f)
    {
        alpha -= 0.01f;
    }
    else // Once the alpha hits zero reset the firework
    {
        initialise();
    }
}

// Create our array of fireworks
Firework fw[FIREWORKS];

// Function to release/destroy our resources and exit
int quit(int returnCode)
{
    // Clean up the window
    SDL_Quit();

    // Exit appropriately
    exit(returnCode);
}


// Function to set some initial OpenGL state-machine properties
int initGL()
{
    //  Enable smooth shading (i.e. gouraud shading)
    glShadeModel(GL_SMOOTH);

    // Set our clear colour to black with full opacity. Syntax is (r, g, b, alpha).
    glClearColor(0.0f, 0.0f, 0.0f, 1.0f);

    // Disable depth testing (because we're working in 2D!)
    glDisable(GL_DEPTH_TEST);

    // Enable blending (we need this to be able to use an alpha component)
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

    // Set the accumulation buffer clearing colour to black at 0,0f alpha
    glClearAccum(0.0f, 0.0f, 0.0f, 1.0f);

    glPointSize(5.0f);

    return 0;
}

// Function to draw our OpenGL scene
int drawScene()
{
    // Set our clear mode to clear the screen -only-
    glClear(GL_COLOR_BUFFER_BIT);

    // Take the contents of the current accumulation buffer and copy it to the colour buffer with each pixel multiplied by a factor
    // i.e. we clear the screen, draw the last frame again (which we saved in the accumulation buffer), then draw our stuff at its new location on top of that
    glAccum(GL_RETURN, 0.95f);

    // Clear the accumulation buffer (don't worry, we re-grab the screen into the accumulation buffer after drawing our current frame!)
    glClear(GL_ACCUM_BUFFER_BIT);

	// Set ModelView matrix mode and reset to the default identity matrix
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

	// Displacement trick for exact pixelisation
	//glTranslatef(0.375, 0.375, 0);

    // Draw fireworks
    //cout << "Firework count is: " << Firework::fireworkCount << endl;
    for (int loop = 0; loop < FIREWORKS; loop++)
    {
        for (int particleLoop = 0; particleLoop < FIREWORK_PARTICLES; particleLoop++)
        {

            // Set the point size of the firework particles (this needs to be called BEFORE opening the glBegin(GL_POINTS) section!)
            glPointSize(fw[loop].particleSize);

            glBegin(GL_POINTS);

                // Set colour to yellow on way up, then whatever colour firework should be when exploded
                if (fw[loop].hasExploded == false)
                {
                    glColor4f(1.0f, 1.0f, 0.0f, 1.0f);
                }
                else
                {
                    glColor4f(fw[loop].red, fw[loop].green, fw[loop].blue, fw[loop].alpha);
                }

                // Draw the point
                glVertex2f(fw[loop].x[particleLoop], fw[loop].y[particleLoop]);
            glEnd();
        }

        // Move the firework appropriately depending on its explosion state
        if (fw[loop].hasExploded == false)
        {
            fw[loop].move();
        }
        else
        {
            fw[loop].explode();
        }
    }

    // Swap active and visual pages to display our output to the screen
    SDL_GL_SwapBuffers();

    // Take the contents of the current draw buffer and copy it to the accumulation buffer with each pixel modified by a factor
    // The closer the factor is to 1.0f, the longer the trails... Don't exceed 1.0f - you get garbage.
    glAccum(GL_ACCUM, 0.9f);

    // Return clean state
    return 0;

} // End of drawScene function

// Function to initialise variables before use
void initVars()
{
    // Seed random number generator
    srand(time(NULL));
}

// Function to reset our viewport after a window resize
int resizeWindow(int width, int height)
{
    // Create a variable for our height/width ratio
    GLfloat ratio;

    // Protect against a divide by zero error when resizing
    if (height == 0)
	{
		height = 1;
	}
	if (width == 0)
	{
		width = 1;
	}

	// Calculate our new (post-resize) window ratio
	if (width > height)
	{
		ratio = (GLfloat)width / (GLfloat)height;
		ratio = (GLfloat)height / (GLfloat)width;
	}
	else
	{
		ratio = (GLfloat)height / (GLfloat)width;
	}

    // Setup our viewport to be the entire size of the window
    glViewport(0, 0, (GLsizei)width, (GLsizei)height);

    // Change to the projection matrix and reset the matrix
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

	// Change to orthographic (2D) projection and switch to the modelview matrix
	glOrtho(0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0, 1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

    return 0;
}


// Function to handle key press events
void handleKeyPress(SDL_keysym *keysym)
{
    switch(keysym->sym)
	{
		case SDLK_ESCAPE: // ESC key pressed? Then quit program
		    quit(0);
			break;

		case SDLK_F1: // F1 key pressed? Then toggle fullscreen mode
		    SDL_WM_ToggleFullScreen(surface);
			break;

		default:
		    // Do nothing by default!
			break;

	} // End of switch statement
}

// Function to set up the screen
void setupScreen(int& videoFlags)
{
    // Create a constant pointer to our SDL_VideoInfo details
    const SDL_VideoInfo *videoInfo;

    // Initialise SDL - quit out if we fail
    if (SDL_Init(SDL_INIT_VIDEO) < 0 )
    {
        fprintf( stderr, "Video initialization failed: %s\n", SDL_GetError() );
		quit(1);
    }

    // Get our video information
    videoInfo = SDL_GetVideoInfo();

    // Quit if we couldn't get any videoInfo values back from our SDL_GetVideoInfo call
    if (!videoInfo)
	{
	    cerr << "Video query failed: " << SDL_GetError() << endl;
	    quit(1);
	}

    // Setup our SDL to use OpenGL with double buffering, a hardware palette and enable window resizing
    videoFlags  = SDL_OPENGL;          // Enable OpenGL in SDL
    videoFlags |= SDL_GL_DOUBLEBUFFER; // Enable double buffering
    videoFlags |= SDL_HWPALETTE;       // Store the palette in hardware
    videoFlags |= SDL_RESIZABLE;       // Enable window resizing

    // Check if our SDL surfaces can be stored in hardware memory or not
    if (videoInfo->hw_available)
	{
		videoFlags |= SDL_HWSURFACE;
    }
	else
	{
		videoFlags |= SDL_SWSURFACE;
	}

    // Do hardware video blits if possible
    if (videoInfo->blit_hw)
	{
		videoFlags |= SDL_HWACCEL;
	}

    // Set up OpenGL for double buffering in SDL
    SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);

    // Get our SDL surface to draw to
    surface = SDL_SetVideoMode(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, videoFlags);

    // Quit out if we can't get a SDL surface
    if (!surface)
	{
	    cerr << "Video mode set failed: " << SDL_GetError() << endl;
	    quit(1);
	}

} // End of setupScreen function


// Function to handle all SDL events appropriately
void controlLoop(int& videoFlags, SDL_Event& event)
{
	// Static var to keep track of whether we should now exit or not
    static bool done = false;

    // Keep going until done is true...
    while (!done)
	{
	    // Handle the events in the queue
	    while ( SDL_PollEvent(&event) )
		{
			// Depending on what event has occured, handle it appropriately
		    switch (event.type) {

				// If the window is resized then call the appropriate resizeWindow function
				case SDL_VIDEORESIZE:
				    surface = SDL_SetVideoMode(event.resize.w, event.resize.h, 16, videoFlags );
				    if (!surface)
					{
					    cerr << "Could not get a surface after resize: " << SDL_GetError() << endl;
					    quit(1);
					}
				    resizeWindow(event.resize.w, event.resize.h);
				    break;

				// If a key is pressed then handle the keypress appropriately
				case SDL_KEYDOWN:
				    handleKeyPress(&event.key.keysym);
				    break;

				case SDL_QUIT:
				    done = true;
				    break;

				// By default, do nothing...
				default:
					// Nothing to see here... move along.
				    break;

			} // End of switch statement

		} // End of while SDL_PollEvent condition

	    // Call the drawScene function to draw our objects to the screen!
	    drawScene();

		// Cheap-as-chips limit framerate to approximately 60fps
		SDL_Delay(16);

	} // End of main while (!done) loop

} // End of controlLoop function


// Our main function
/*int main(int argc, char **argv)
{
    // Flags to pass to SDL_SetVideoMode - made global for use in setupScreen and controlLoop functions
    int videoFlags;

    // SDL_Event type variable to keep track of events - used in our controlLoop function
    SDL_Event event;

    // Set up our screen
    setupScreen(videoFlags);

    // Set the window and tray caption
    SDL_WM_SetCaption("Simple OpenGL Fireworks with Trails | r3dux.org", "Fireworks w/ Trails");

    // Initialise our variables
    initVars();

    // Initialise OpenGL
    initGL();

    // Resize the initial window
    resizeWindow(SCREEN_WIDTH, SCREEN_HEIGHT);

    // Call our control loop - this the main loop that keeps on running until user quits program with Esc or by closing the display window
    controlLoop(videoFlags, event);

    // Clean ourselves up and exit
    quit(0);

    // We will never get here because our quit function will exit or us - but we'll put this return in for the sake of correctness!
    return 0;
}*/

//////////PARTICULA END
int main(int argc, char *argv[]) {
    //av = getAvion(1,1,1,0,0,0,0);
    //DEFINICION E INICIALIZACIN DE COORDENADAS Y PARMETROS

    ultimogenerado = clock();
    puntaje = 0;
    ultimoavgenerado = ultimogenerado;
    coordCitys[0][0] = 0.0;clock();//{0.0,0.5,0.0};
    coordCitys[1][0] = -sqrt(3.0/4.0)/2.0;
    coordCitys[2][0] = sqrt(3.0/4.0)/2.0;
    coordCitys[0][1] = 0.5;
    coordCitys[1][1] = -0.5;
    coordCitys[2][1] = -0.5;
    coordCitys[0][2] = 0.0;
    coordCitys[1][2] = 0.0;
    coordCitys[2][2] = 0.0;
    vidaCitys[0]=100;
    vidaCitys[1]=100;
    vidaCitys[2]=100;
    coordavion[0] = 2.5;
    coordavion[1] = 1.5;
    coordavion[2] = 2.0;
    float coordcannon[8] = {   0.0,2.0,
                                2.0,0.0,
                                -2.0,0.0,
                                0.0,-2.0  };
    float anglecannon[4] = {   0.0,90.0,
                                180.0,270.0  };
    float zoom = 1;
    ShowCursor(false);
    float angb=0;
    float angulo=0;
    float rad=-5;
    bool moverCam=false;
    bool wireframe= false;
    if(SDL_Init(SDL_INIT_VIDEO)<0) {
        cerr << "No se pudo iniciar SDL: " << SDL_GetError() << endl;
        exit(1);
    }
    atexit(SDL_Quit);
    Uint32 flags = SDL_DOUBLEBUF | SDL_HWSURFACE | SDL_OPENGL;
    if(SDL_SetVideoMode(640, 480, 32, flags)==NULL) {
        cerr << "No se pudo establecer el modo de video: " << SDL_GetError() << endl;
        exit(1);
    }
    if(SDL_EnableKeyRepeat(10, 10)<0) {
        cerr << "No se pudo establecer el modo key-repeat: " << SDL_GetError() << endl;
        exit(1);
    }
    glMatrixMode(GL_PROJECTION);
    float color = 0;
    glClearColor(color, color, color, 1);
    gluPerspective(45, 640/480.f, 0.1, 100);
    glEnable(GL_DEPTH_TEST);
    glMatrixMode(GL_MODELVIEW);


    char* archivo = new char[20];
    //archivo = "canon.png";


    GLuint textura[CANT_TXTR];
    glGenTextures(CANT_TXTR, textura);
    int i = 0;

    archivo = "Brick_pattern2.jpg";//TOWER 0
    loadTexture(archivo, textura, i); i++;
    archivo = "avion.jpg";//MISIL 1
    loadTexture(archivo, textura, i); i++;
    archivo = "canon.png";//CAON 2
    loadTexture(archivo, textura, i); i++;
    archivo = "JLGreebleProof-CorrelateIMG_0006.jpg";//HOUSE 3
    loadTexture(archivo, textura, i); i++;
    //archivo = "galaxy_texture_by_bublla-d5of0bm.png";//CIELO 4
    archivo = "ralternatebluegalaxyprint_shop_preview.png";//CIELO 4
    //archivo = "nishantsp1.jpg";//CIELO 4
    loadTexture(archivo, textura, i); i++;
    archivo = "nishantsp1.jpg";//PISO 5
    //archivo = "NiliFossae_co_xl.jpg";//PISO 5
    //archivo = "space-spiders-670.jpg";//PISO 5
    //archivo = "Mgn_p39146.png";//PISO 5
    //archivo = "piso1.jpg";//PISO 5

    loadTexture(archivo, textura, i); i++;
    archivo = "menu.jpg";//MENU 6
    loadTexture(archivo, textura, i); i++;
    archivo = "menu3.jpg";//MENU 7
    loadTexture(archivo, textura, i); i++;

    vector< ::textura> tAvion;
    vector<vertice> nAvion;
    vector<vertice> vAvion;
    vector<Poligono> oAvion;
    oAvion = cargarObjeto("Drone.obj",0.2,vAvion,tAvion,nAvion);

    vector< ::textura> tMisil;
    vector<vertice> nMisil;
    vector<vertice> vMisil;
    vector<Poligono> oMisil;
    oMisil = cargarObjeto("asca.obj",0.2,vMisil,tMisil,nMisil);

    bool fin=false;
    SDL_Event evento;
    float aspecto = 212/452.f;
    float escala = 1;
    float angulo_canion[CANT_CANION] = {angulo, angulo, angulo, angulo};
    float altura_tower [CANT_TOWER] = {0.7, 0.7, 0.7, 0.7};
    int nro_canion = 0;
    bool hitavion = false;
    float lx,lz;

    x=coordcannon[2];
    y=coordcannon[3];
    z=2.025;
    nro_canion = 1;

    ///MENU
        bool pausa = false;
        bool config=false;
        bool light=true;
    ///MENU END

    ///PARTICULAS
// Flags to pass to SDL_SetVideoMode - made global for use in setupScreen and controlLoop functions
    int videoFlags;

    // SDL_Event type variable to keep track of events - used in our controlLoop function
    //SDL_Event event;

    // Set up our screen
    //setupScreen(videoFlags);

    // Set the window and tray caption
    //SDL_WM_SetCaption("Simple OpenGL Fireworks with Trails | r3dux.org", "Fireworks w/ Trails");

    // Initialise our variables
    initVars();

    // Initialise OpenGL
    initGL();

    // Resize the initial window
    //resizeWindow(SCREEN_WIDTH, SCREEN_HEIGHT);

    // Call our control loop - this the main loop that keeps on running until user quits program with Esc or by closing the display window
    //controlLoop(videoFlags, event);
///PARTICULAS END

    do{

        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
        float comp;
        glLoadIdentity();


if (pausa){
    glEnable(GL_TEXTURE_2D);
            glBindTexture(GL_TEXTURE_2D, textura[TXTR_MENU]);
            menu();
        glDisable(GL_TEXTURE_2D);
        while(SDL_PollEvent(&evento)){
            switch(evento.type){
            case SDL_QUIT:
                fin = true;
                break;
            case SDL_KEYDOWN:
                switch(evento.key.keysym.sym){
                case SDLK_ESCAPE:
                    fin = true;
                    break;
                case SDLK_1:
                    pausa=false;
                    //Sleep(200);
                    break;
                case SDLK_c:
                    config=true;
                    pausa=false;
                    //Sleep(200);
                    break;
                }
                break;
            }
        }
}else if (config){
    glEnable(GL_TEXTURE_2D);
            glBindTexture(GL_TEXTURE_2D, textura[TXTR_MENU2]);
            menu();
        glDisable(GL_TEXTURE_2D);
        while(SDL_PollEvent(&evento)){
            switch(evento.type){
            case SDL_QUIT:
                fin = true;
                break;
            case SDL_KEYDOWN:
                switch(evento.key.keysym.sym){
                case SDLK_q:
                    pausa=true;
                    config=false;
                    Sleep(200);
                    break;
                case SDLK_w:
                    wireframe=true;
                    Sleep(200);
                    break;
                case SDLK_l:
                    light=!light;
                    Sleep(200);
                    break;
                }
                break;
            }
        }
}else{


        generarAviones(ultimoavgenerado,3,av,0.5,canthitrest,coordavion,hayavion);

        generarMisiles(ultimogenerado,coordCitys,buffmisiles,cantmisiles,3,cantvivos,vidaCitys);

        //Se calculan las trayectorias y la camara.

        calcularmisiles(buffmisiles,cantmisiles,cantvivos,0.5,coordCitys,vidaCitys);
        if(hayavion)
            calcularavion(av,canthitrest,hayavion);
        calcularLookAt(nro_canion,comp,coordcannon,x,y,z,lz);
        glTranslatef(0.0,0.0,0.0);
        glRotatef(anglecannon[nro_canion],x,y,-z);


        float pos[] = {0.0,0.0,0.0,1.0};
        glLightfv(GL_LIGHT0, GL_POSITION, pos);
        float length=2;
        float hl = length * 0.5f;
        float radius=0.4;
        int numSteps=100;
        float arrX_1[numSteps+1];
        float arrY_1[numSteps+1];
        float arrX_2[numSteps+1];
        float arrY_2[numSteps+1];
        int posx, posy;
        SDL_GetMouseState(&posx,&posy);
        GLdouble modelview[16];
        GLint viewport[4];
        GLdouble projection[16];
        GLdouble winX,winY,winZ;
        GLdouble posiX,posiY,posiZ;
        glGetDoublev(GL_MODELVIEW_MATRIX,modelview);
        glGetDoublev(GL_PROJECTION_MATRIX,projection);
        glGetIntegerv(GL_VIEWPORT,viewport);
        winX = (float)posx;
        winY = (float)viewport[3] - (float)posy;
        glReadPixels(x,int(winY),1,1,GL_DEPTH_COMPONENT,GL_FLOAT,&winZ);
        gluUnProject(winX,winY,winZ,modelview,projection,viewport,&posiX,&posiY,&posiZ);
        glColor3f(RMISIL,GMISIL,BMISIL);
        if(wireframe){
            glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
        }
        else{
            glPolygonMode( GL_FRONT_AND_BACK, GL_FILL  );
        }
        //SE dibujan todos los modelos 3D
        glEnable(GL_TEXTURE_2D);
        glBindTexture(GL_TEXTURE_2D, textura[TXTR_MISIL]);
        drawmisiles(40,buffmisiles,cantmisiles, vMisil, tMisil, nMisil, oMisil);
        drawavion(40,av,canthitrest,hitavion,vAvion,tAvion,nAvion,oAvion);
        glDisable(GL_TEXTURE_2D);

        glEnable(GL_TEXTURE_2D);

        glBindTexture(GL_TEXTURE_2D, textura[TXTR_TORRE]);
            dibujartorres(coordcannon,altura_tower,angulo_canion);
        glBindTexture(GL_TEXTURE_2D, textura[TXTR_CANION]);
            dibujarcaniones(coordcannon,altura_tower,angulo_canion);
        glBindTexture(GL_TEXTURE_2D, textura[TXTR_HOUSE]);
            dibujarciudades(coordCitys,vidaCitys);
        glBindTexture(GL_TEXTURE_2D, textura[TXTR_CIELO]);
            cielitoLindo(0.0, 0.0, 0.0, 30.0, 300);
        glBindTexture(GL_TEXTURE_2D, textura[TXTR_PISO]);
            ground(0.0, 0.0, 0.0, 30.0, 300);

    /*glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        glOrtho(0,480,0,640,-1,1);
        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();*/
        //glBindTexture(GL_TEXTURE_2D, textura[TXTR_MENU]);
        //    menu();
        glDisable(GL_TEXTURE_2D);
   //glMatrixMode(GL_PROJECTION);


        //glLoadIdentity();




        glEnd();
        float ip,jp;
        int xm,ym,xn,yn;
        SDL_GetMouseState(&xm, &ym);
        glDisable(GL_TEXTURE_2D);
        while(SDL_PollEvent(&evento)){
            switch(evento.type){
            /*case SDL_VIDEORESIZE:
				    surface = SDL_SetVideoMode(evento.resize.w, evento.resize.h, 16, videoFlags );
				    if (!surface)
					{
					    cerr << "Could not get a surface after resize: " << SDL_GetError() << endl;
					    quit(1);
					}
				    resizeWindow(evento.resize.w, evento.resize.h);
				    break;*/
            case SDL_MOUSEBUTTONDOWN:
                if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(3)){
                    moverCam=true;
                }
                if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1)){
                    for(int i=0;i<cantmisiles;i++){
                        if(buffmisiles[i].vivo){
                            if(isHit(x,y,-z,posiX,posiY,posiZ,buffmisiles[i].xActual,buffmisiles[i].yActual,buffmisiles[i].zActual,RADIO_MISIL)){
                                hitMisil(i,buffmisiles,cantvivos,puntaje, true);
                            }
                        }
                    }
                    if(hayavion){
                        if(isHit(x,y,-z,posiX,posiY,posiZ,av.xActual,av.yActual,av.zActual,RADIO_AVION)){
                            hitAvion(av,canthitrest,puntaje);
                            if(not(av.vivo)){
                                hayavion=false;
                            }else{
                                hitavion = true;
                            }
                        }
                    }
                }

                break;
            case SDL_MOUSEBUTTONUP:
                moverCam=false;
                break;
            case SDL_MOUSEMOTION:
                if(moverCam){
                        angb-=evento.motion.yrel*0.4;
                    lz=angb;
                }
                break;
            case SDL_QUIT:
                fin = true;
                break;
            case SDL_KEYDOWN:
                switch(evento.key.keysym.sym){
                case SDLK_ESCAPE:
                    fin = true;
                    break;
                case SDLK_LEFT:
                    if(angulo_canion[nro_canion]<45)
                        angulo_canion[nro_canion] += 1;
                    nro_canion=(nro_canion +3)% CANT_CANION;
                    angb=0;
                    lz=0;
                    x= coordcannon[nro_canion*2];
                    y= coordcannon[nro_canion*2+1];
                    Sleep(200);
                    break;
                case SDLK_RIGHT:
                    if(angulo_canion[nro_canion]>-45)
                        angulo_canion[nro_canion] -= 1;
                    nro_canion=(nro_canion +1)% CANT_CANION;
                    angb=0;
                    lz=0;
                    x= coordcannon[nro_canion*2];
                    y= coordcannon[nro_canion*2+1];
                    Sleep(200);
                    break;
                case SDLK_w:
                    wireframe = not(wireframe);
                    Sleep(200);
                    break;
                case SDLK_p:
                    pausa=true;
                    Sleep(200);
                    break;
                case SDLK_UP:
                    if(zoom<2)
                        zoom = zoom*1.2;
                    Sleep(50);
                    break;
                case SDLK_DOWN:
                    if(zoom>1)
                        zoom = zoom/1.2;
                    Sleep(50);
                    break;
                case SDLK_F11:
                    flags ^= SDL_FULLSCREEN;
                    //flags = SDL_FULLSCREEN;
                    if(SDL_SetVideoMode(640, 480, 32, flags)==NULL) {
                        fprintf(stderr, "No se pudo establecer el modo de video: %s\n", SDL_GetError());
                        exit(1);
                    }
                    glMatrixMode(GL_PROJECTION);
                    float color = 0;
                    glClearColor(color, color, color, 1);
                    gluPerspective(45, 640/480.f, 0.1, 100);
                    glMatrixMode(GL_MODELVIEW);
                    break;
                }
                break;
            }
        }
        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        glOrtho(0,480,0,640,-1,1);
        glMatrixMode(GL_MODELVIEW);
        glLoadIdentity();
            glBegin(GL_LINES);
                //HUD
                glColor3f(255.0,255.0,255.0);
                glVertex2d(winX/1.33-10,winY*1.3251);
                glVertex2d(winX/1.33+10,winY*1.3251);
                glVertex2d(winX/1.33,winY*1.3251+15);
                glVertex2d(winX/1.33,winY*1.3251-15);

                //-------

            glEnd();
            float aspecty = 640.0/480.0;
            float aspectx = 480.0/640.0;
            float escala = 20;
            float offsetx = 10;
            float offsety = 480-escala*aspecty;
            float offsetz = 0;
            glColor3f(0.0,1.0,0.0);
            printNumers(aspectx,aspecty,escala,offsetx,offsety,offsetz,puntaje,false);
            offsety = 480 - escala;
            offsetx = 640-escala*8+10;
            escala = 15;
            printCitys(aspectx,aspecty,escala,offsetx,offsety,offsetz,vidaCitys);
        glMatrixMode(GL_PROJECTION);


        glLoadIdentity();

        float color = 0;
        glClearColor(color, color, color, 1);
        gluPerspective(45/zoom, 640/480.f, 0.1, 100);
        glEnable(GL_DEPTH_TEST);
        glMatrixMode(GL_MODELVIEW);
}



        SDL_GL_SwapBuffers();
        // Call the drawScene function to draw our objects to the screen!
	    //drawScene();
        // Cheap-as-chips limit framerate to approximately 60fps
		SDL_Delay(16);

    }while(!fin);
    return 0;
}

Poligono procesarPoligono(string linea){
	Poligono pol;
	string::iterator it = linea.begin();
    while (it != linea.end()){
        string vertex, texture, normal;
        int vAux, tAux, nAux;
        for (; *it == ' '; it++);
        for (; *it != '/'; it++)
            vertex += *it;
        for (; *it == ' '; it++);
        for (it++; *it != '/'; it++)
            texture += *it;
        for (; *it == ' '; it++);
        for (it++; *it != ' ' && it != linea.end(); it++)
            normal += *it;
        istringstream(vertex) >> vAux;
        istringstream(texture) >> tAux;
        istringstream(normal) >> nAux;
		vAux--;
		tAux--;
		nAux--;
        pol.vertices.push_back(vAux);
        pol.texturas.push_back(tAux);
        pol.normales.push_back(nAux);
        if (it != linea.end())
            it++;
        }
	return pol;
}

vertice procesarVertice(string linea, float escalamiento){
	vertice ver;
	string::iterator it = linea.begin();
    string x, y, z;
    for (; *it == ' '; it++);
    for (; *it != ' '; it++)
        x += *it;
    for (; *it == ' '; it++);
    for (it++; *it != ' '; it++)
        y += *it;
    for (; *it == ' '; it++);
    for (it++; *it != ' ' && it != linea.end(); it++)
        z += *it;
    istringstream(x) >> ver.x;
    istringstream(y) >> ver.y;
    istringstream(z) >> ver.z;
    ver.x = ver.x * escalamiento;
    ver.y = ver.y * escalamiento;
    ver.z = ver.z * escalamiento;
	return ver;
}

vertice procesarNormal(string linea){
	vertice nor;
	string::iterator it = linea.begin();
    string x, y, z;
    for (; *it == ' '; it++);
    for (; *it != ' '; it++)
        x += *it;
    for (; *it == ' '; it++);
    for (it++; *it != ' '; it++)
        y += *it;
    for (; *it == ' '; it++);
    for (it++; *it != ' ' && it != linea.end(); it++)
        z += *it;
    istringstream(x) >> nor.x;
    istringstream(y) >> nor.y;
    istringstream(z) >> nor.z;
	return nor;
}

textura procesarTextura(string linea){
	textura tex;
	string::iterator it = linea.begin();
    string x, y;
    for (; *it == ' '; it++);
    for (; *it != ' '; it++)
        x += *it;
    for (; *it == ' '; it++);
    for (it++; *it != ' ' && it != linea.end(); it++)
        y += *it;
    istringstream(x) >> tex.x;
    istringstream(y) >> tex.y;
	return tex;
}


void dibujarObjeto(vector<Poligono> pols, vector<vertice> vertices, vector<textura> texturado, vector<vertice> normales){
        for (int i = 0; i < pols.size(); i++){
            glBegin(GL_POLYGON);
            for (int j = 0; j < pols[i].vertices.size(); j++){
                glNormal3f(normales[pols[i].normales[j]].x,normales[pols[i].normales[j]].y,normales[pols[i].normales[j]].z);
                glTexCoord2f(texturado[pols[i].texturas[j]].x,texturado[pols[i].texturas[j]].y);
                glVertex3f(vertices[pols[i].vertices[j]].x,vertices[pols[i].vertices[j]].y,vertices[pols[i].vertices[j]].z);
            }
            glEnd();
        }
}

vector<Poligono> cargarObjeto(const char* filename, float escalamiento, vector<vertice> &vertices,
                              vector<textura> &texturas, vector<vertice> &normales) {
    ifstream in(filename, ios::in);
    vector<Poligono> elementos;

    if (!in) { cerr << "No se pudo abrir el archivo " << filename << endl; exit(1); }

    string linea;
    while (getline(in, linea)) {
        if (linea.substr(0,2) == "v ") {
            linea.replace(0,2,"");
            vertices.push_back(procesarVertice(linea, escalamiento));
        } else if (linea.substr(0,2) == "f ") {
            linea.replace(0,2,"");
            elementos.push_back(procesarPoligono(linea));
        } else if (linea.substr(0,3) == "vt ") {
            linea.replace(0,3,"");
            texturas.push_back(procesarTextura(linea));
        } else if (linea.substr(0,3) == "vn ") {
            linea.replace(0,3,"");
            normales.push_back(procesarNormal(linea));
        }
    }
    vertice verticeAux;
    textura texturaAux;
    verticeAux.x = 0;
    verticeAux.y = 0;
    verticeAux.z = 0;
    texturaAux.x = 0;
    texturaAux.y = 0;
    normales.resize(vertices.size(), verticeAux);
    texturas.resize(vertices.size(), texturaAux);
    return elementos;
}


