#ifndef LOADER_H_INCLUDED
#define LOADER_H_INCLUDED

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <math.h>
#include "SDL/SDL_opengl.h"
#include "FreeImage.h"

#define MAX_VERTICES 8000// Max number of vertices (for each object)
#define MAX_POLYGONS 8000// Max number of polygons (for each object)

// Our vertex type
typedef struct{
    float x,y,z;
}vertex_type;

// The polygon (triangle), 3 numbers that aim 3 vertices
typedef struct{
    int a,b,c;
    vertex_type normal;
}polygon_type;

// The mapcoord type, 2 texture coordinates for each vertex
typedef struct{
    float u,v;
}mapcoord_type;

// The object type
typedef struct {
	char name[20];

	int vertices_qty;
    int polygons_qty;

    vertex_type vertex[MAX_VERTICES];
    polygon_type polygon[MAX_POLYGONS];
    mapcoord_type mapcoord[MAX_VERTICES];
    int id_texture;
} obj_type, *obj_type_ptr;

extern char Load3DS (obj_type_ptr ogg, char *filename);

extern void drawObject(obj_type object);

#endif // LOADER_H_INCLUDED
