#include "cargadorConfiguracion.h"
#include "3DSLoader.h"

bool cargarConfiguracion(char* nombre, map<int,map<int,Ciudad*> > &ciudades, Torre* torres[3], float torres_posiciones[3][3]){
    TiXmlDocument doc(nombre);
	doc.LoadFile();

	TiXmlHandle hDoc(&doc);
	TiXmlElement *pRoot;

	int lvl,id,mun,salud;
	float x;
	float y;
	float z;

    //Cargo  las posiciones de las cuidades en los diferentes niveles
    pRoot = doc.FirstChildElement("niveles");
	pRoot = pRoot->FirstChildElement("salud");
	salud = (int)atof(pRoot->Attribute("valor"));

	pRoot = doc.FirstChildElement("niveles");
	pRoot = pRoot->FirstChildElement("ciudad");

	while (pRoot) {
		lvl = (int)atof(pRoot->Attribute("lvl"));
		id = (int)atof(pRoot->Attribute("id"));
		x = (float)atof(pRoot->Attribute("x"));
		y = (float)atof(pRoot->Attribute("y"));
		z = (float)atof(pRoot->Attribute("z"));
		Ciudad* c = new Ciudad(x,y,z,salud);
		ciudades[lvl][id] = c;
		pRoot = pRoot->NextSiblingElement();
	}

    //Cargo  las posiciones de las torres
    pRoot = doc.FirstChildElement("torres");
	pRoot = pRoot->FirstChildElement("municion");
	mun = (int)atof(pRoot->Attribute("cant"));

	pRoot = doc.FirstChildElement("torres");
	pRoot = pRoot->FirstChildElement("torre");

	while (pRoot) {
		id = (int)atof(pRoot->Attribute("id"));
		x = (float)atof(pRoot->Attribute("x"));
		y = (float)atof(pRoot->Attribute("y"));
		z = (float)atof(pRoot->Attribute("z"));
		torres_posiciones[id][0] = x;
		torres_posiciones[id][1] = y;
		torres_posiciones[id][2] = z;
		CCamera* c = new CCamera();
		torres[id] = new Torre(c,mun);
		pRoot = pRoot->NextSiblingElement();
	}
}
