#define _USE_MATH_DEFINES

#ifndef VECTOR3D_H
#define VECTOR3D_H

#include <cmath>
#include <sstream>

using namespace std;

class Vector3D {
private:
	float mod, x, y, z;
	float A[3];
public:
	Vector3D();
	Vector3D(float, float, float);
	Vector3D operator=(const Vector3D&);
	float anguloCon(const Vector3D&) const;
	float getX() const;
	float getY() const;
	float getZ() const;
	float modulo() const;
	float moduloAlCuadrado() const;
	void normalizar();
	void setXYZ(float, float, float);
	void incrementarX(float dX);
	void incrementarY(float dY);
	void incrementarZ(float dZ);
	Vector3D simetricoSegun(const Vector3D&) const;
	Vector3D rotar(Vector3D eje, float angulo); // angulo en grados
	float distanciaCon(Vector3D);
	Vector3D operator+() const;
	Vector3D operator-() const;
	Vector3D operator+(const Vector3D&) const;
	Vector3D operator+=(const Vector3D&);
	Vector3D operator-(const Vector3D&) const;
	Vector3D operator-=(const Vector3D&);
	float operator*(const Vector3D&) const; // Producto interno.
	Vector3D operator/(const Vector3D&) const; // Producto vectorial.
	Vector3D operator/=(const Vector3D&);
	Vector3D operator*(const float&) const;
	Vector3D operator/(const float&) const;
	bool operator==(const Vector3D&) const;
	bool operator!=(const Vector3D&) const;
	friend Vector3D operator*(const float&, const Vector3D&);
	friend ostream& operator<<(ostream&, const Vector3D&);
	friend istream& operator>>(istream&, Vector3D&);
	float* a_3v();
	virtual ~Vector3D();
};

#endif // VECTOR3D_H
