#include "..\headers\Hud.h"
#include "GL\glut.h"

Hud::Hud()
{
	posXHud = 0.6;
	posYHud = -0.5;
	posXInfo = -1.0;
	posYInfo = -0.5;
	nivel = new char[1]();
	puntaje = new char[3]();
	cantidadCanones = new char[1]();
	FPS = new char[2]();
	wireframeOn = new char[3]();
	facetadoOInterpolado = new char[12]();
	texturasOn = new char[3]();
	luzActivada = new char[3]();
	ciudadesRestantes = new char[1]();
}

void renderBitmapString(float x, float y,const char *string){
    const char *c;
	glColor3f(1.0, 1.0, 1.0);
    glRasterPos2f(x, y);
    for (c=string; *c != '\0'; c++) {
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, *c);
    }
}

void Hud::setPuntaje(int p)
{
	_itoa(p, puntaje, 10);
}

void Hud::setNivel(int n)
{
	_itoa(n, nivel, 10);
}

void Hud::setCiudadesRestantes(int cr)
{
	_itoa(cr, ciudadesRestantes, 10);
}

void Hud::setCantCanones(int cc)
{
	_itoa(cc, cantidadCanones, 10);
}

void Hud::setFPS(int f)
{
	_itoa(f, FPS, 10);
}

void Hud::setWireFrame(bool w)
{
	if (w)
		wireframeOn = "On";
	else
		wireframeOn = "Off";
}

void Hud::setFacetado(bool f)
{
	if (f)
		facetadoOInterpolado = "Facetado";
	else
		facetadoOInterpolado = "Interpolado";
}

void Hud::setTexturas(bool t)
{
	if (t)
		texturasOn = "On";
	else
		texturasOn = "Off";
}

void Hud::setLuz(int l)
{
	if (l)
		luzActivada = "On";
	else
		luzActivada = "Off";
}

void Hud::draw(bool info, bool perdiste, int level)
{
	glMatrixMode( GL_PROJECTION );
	glPushMatrix();
	glLoadIdentity();

	glDisable(GL_DEPTH_TEST);
	glOrtho(-1.0f, 1.0f, -1.0f, 1.0f, 0.01f, 3.0f);
	gluLookAt(0,0,1,0, 0, 0, 0, 1, 0);

	glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();
		
	
	if (level == -1)
	{
		if (perdiste)
		{
			glEnable(GL_BLEND);
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			glColor4f(1.0f, 0.5f, 0.5f, 0.8f);
			glBegin(GL_POLYGON);
			glVertex3f(-80.0f, -60.0f, 0.0f);
			glVertex3f(-80.0f, 60.0f, 0.0f);
			glVertex3f(80.0f, 60.0f, 0.0f);
			glVertex3f(80.0f, -60.0f, 0.0f);
			glEnd();
			glDisable(GL_BLEND);

			renderBitmapString(-0.2f, 0.0f, "Perdiste, tu puntaje fue ");
			renderBitmapString(0.0f, -0.1f, puntaje);
			renderBitmapString(-0.3f, -0.2f, "Para volver a jugar pulsar la tecla R ");
		}
		else
		{
			renderBitmapString(-1.0, 0.95, "F1 para Info");
			renderBitmapString(posXHud, posYHud - 0.1, "Nivel: ");
			renderBitmapString(posXHud + 0.3, posYHud - 0.1, nivel);
			renderBitmapString(posXHud, posYHud - 0.2, "Canones: ");
			renderBitmapString(posXHud + 0.3, posYHud - 0.2, cantidadCanones);
			renderBitmapString(posXHud, posYHud - 0.3, "Ciudades: ");
			renderBitmapString(posXHud + 0.3, posYHud - 0.3, ciudadesRestantes);
			renderBitmapString(posXHud, posYHud - 0.4, "Puntaje: ");
			renderBitmapString(posXHud + 0.3, posYHud - 0.4, puntaje);

			if (info)
			{
				renderBitmapString(posXInfo, posYInfo - 0.1, "OPCIONES");
				renderBitmapString(posXInfo, posYInfo - 0.2, "W: Wireframe On/Off ");
				renderBitmapString(posXInfo + 0.55, posYInfo - 0.2, wireframeOn);
				renderBitmapString(posXInfo, posYInfo - 0.3, "F: Facetado/Interpolado  ");
				renderBitmapString(posXInfo + 0.55, posYInfo - 0.3, facetadoOInterpolado);
				renderBitmapString(posXInfo, posYInfo - 0.4, "T: Texturas On/Off  ");
				renderBitmapString(posXInfo + 0.55, posYInfo - 0.4, texturasOn);
				renderBitmapString(posXInfo, posYInfo - 0.5, "I: Iluminacion On/Off  ");
				renderBitmapString(posXInfo + 0.55, posYInfo - 0.5, luzActivada);
			}
		}
	}
	else
	{
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glColor4f(0.0f, 1.0f, 0.5f, 0.8f);
		glBegin(GL_POLYGON);
		glVertex3f(-80.0f, -60.0f, 0.0f);
		glVertex3f(-80.0f, 60.0f, 0.0f);
		glVertex3f(80.0f, 60.0f, 0.0f);
		glVertex3f(80.0f, -60.0f, 0.0f);
		glEnd();
		glDisable(GL_BLEND);

		renderBitmapString(-0.2f, 0.0f, "Pasaste al nivel");
		renderBitmapString(0.0f, -0.1f, nivel);
	}
	
	
	glEnable(GL_DEPTH_TEST);

	glPopMatrix();	
	glPopMatrix();
}

Hud::~Hud()
{
}