#include "../headers/Light.h"


Light::Light()
{
	lightPosition[0] = 0.0f;
	lightPosition[1] = 0.0f;
	lightPosition[2] = 0.0f;
	lightPosition[3] = 1.0f;
	lightAmbient[0] = 0.2f;
	lightAmbient[1] = 0.2f;
	lightAmbient[2] = 0.2f;
	lightAmbient[3] = 1.0f;
	lightDiffuse[0] = 0.8f;
	lightDiffuse[1] = 0.8f;
	lightDiffuse[2] = 0.8f;
	lightDiffuse[3] = 1.0f;

	state = true;
}

void Light::setPosX(float x)
{
	lightPosition[0] = x;
	glLightfv(GL_LIGHT1, GL_POSITION, lightPosition);
}

void Light::setPosY(float y)
{
	lightPosition[1] = y;
	glLightfv(GL_LIGHT1, GL_POSITION, lightPosition);
}

void Light::setPosZ(float z)
{
	lightPosition[2] = z;
	glLightfv(GL_LIGHT1, GL_POSITION, lightPosition);
}

void Light::setColorR(float r)
{
	lightAmbient[0] = r;
	lightDiffuse[0] = r;
	glLightfv(GL_LIGHT1, GL_AMBIENT, lightAmbient);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, lightDiffuse);
}

void Light::setColorG(float g)
{
	lightAmbient[1] = g;
	lightDiffuse[1] = g;
	glLightfv(GL_LIGHT1, GL_AMBIENT, lightAmbient);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, lightDiffuse);
}

void Light::setColorB(float b)
{
	lightAmbient[2] = b;
	lightDiffuse[2] = b;
	glLightfv(GL_LIGHT1, GL_AMBIENT, lightAmbient);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, lightDiffuse);
}

GLfloat Light::getPosition(unsigned int axis)
{
	return lightPosition[axis];
}
GLfloat Light::getColor(unsigned int type)
{
	return lightAmbient[type];
}

bool Light::getState()
{
	return state;
}

void Light::enable()
{
	state = true;
	glEnable(GL_LIGHT1);
}

void Light::disable()
{
	state = false;
	glDisable(GL_LIGHT1);
}

Light::~Light()
{
}
