#include "..\headers\MenuScreen.h"

MenuScreen::MenuScreen()
{
	posY = 0.045f;
	opcion_actual = COMENZAR;

	char* imagen;
	imagen = img_screen;

	glGenTextures(1, &(textura));
	SDL_Surface* img = SDL_LoadBMP(imagen);
	glGenTextures(1, &(textura));
	glBindTexture(GL_TEXTURE_2D, textura);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, img->w, img->h, 0, GL_BGR, GL_UNSIGNED_BYTE, img->pixels);
	SDL_FreeSurface(img);
}

void MenuScreen::draw()
{
	// Seteo OpenGL settings
    glDisable( GL_LIGHTING );
	glPushMatrix();
    glEnable( GL_TEXTURE_2D );

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
	
	glBindTexture(GL_TEXTURE_2D, textura);
	glBegin( GL_QUADS );
		glTexCoord2d( 0.0f, 1.0f ); glVertex3f(-1.0,-1.0, -0.5f);
        glTexCoord2d( 0.0f, 0.0f ); glVertex3f(-1.0, 1.0, -0.5f);
		glTexCoord2d( 1.0f, 0.0f ); glVertex3f( 1.0, 1.0, -0.5f);
		glTexCoord2d( 1.0f, 1.0f ); glVertex3f( 1.0,-1.0, -0.5f);
    glEnd();
	glDisable( GL_TEXTURE_2D );
	DibujarPuntero();
	glPopMatrix();
	glEnable(GL_LIGHTING);
}

void MenuScreen::DibujarPuntero()
{
	glEnable(GL_DEPTH_TEST);
	glBegin(GL_TRIANGLES);
        glColor3f(1.0, 1.0, 0.0);
        glVertex3f(X_WELCOME_INIT-0.05,(posY + (opcion_actual * difOpciones))-0.05,-0.5);
        glVertex3f(X_WELCOME_INIT-0.05,(posY + (opcion_actual * difOpciones))+0.05,-0.5);
        glVertex3f(X_WELCOME_INIT+0.05,(posY + (opcion_actual * difOpciones)),-0.5);
	glEnd();
	glDisable(GL_DEPTH_TEST);
}

void MenuScreen::siguiente()
{
	opcion_actual = (opcion_actual + 1) % 3;
}

void MenuScreen::anterior()
{
	opcion_actual = (opcion_actual - 1);
	if (opcion_actual < 0)
		opcion_actual = 2;
}

int MenuScreen::procesarEnter()
{
	switch (opcion_actual)
	{
		case COMENZAR:
			return 2;
			break;
		case AJUSTES:
			 return 2;
			 break;
		case SALIR:
			 return 0;
			 break;
	}
}

MenuScreen::~MenuScreen()
{
	glDeleteTextures(1, &textura);
}
