#include "../headers/Model3D.h"
#include <sys/stat.h>

long filelength(int f)
{
    struct stat buf;

    fstat(f, &buf);

    return(buf.st_size);
}


char Load3DS (obj_type_ptr p_object, char *p_filename)
{
	int i;

	FILE *l_file;

	unsigned short l_chunk_id;
	unsigned int l_chunk_lenght;

	unsigned char l_char;
	unsigned short l_qty;

	unsigned short l_face_flags;

	if ((l_file=fopen (p_filename, "rb"))== NULL) return 0;

	while (ftell (l_file) < filelength (_fileno (l_file)))
	{
		fread (&l_chunk_id, 2, 1, l_file);
		fread (&l_chunk_lenght, 4, 1, l_file);

		switch (l_chunk_id)
        {
			case 0x4d4d:
				break;

			case 0x3d3d:
				break;

			case 0x4000:
				i=0;
				do
				{
					fread (&l_char, 1, 1, l_file);
                    p_object->name[i]=l_char;
					i++;
                }while(l_char != '\0' && i<20);
				break;

			case 0x4100:
				break;

			case 0x4110:
				fread (&l_qty, sizeof (unsigned short), 1, l_file);
                p_object->vertices_qty = l_qty;
                for (i=0; i<l_qty; i++)
                {
					fread (&p_object->vertex[i].x, sizeof(float), 1, l_file);
                    fread (&p_object->vertex[i].y, sizeof(float), 1, l_file);
					fread (&p_object->vertex[i].z, sizeof(float), 1, l_file);
				}
				break;

			case 0x4120:
				fread (&l_qty, sizeof (unsigned short), 1, l_file);
                p_object->polygons_qty = l_qty;
                for (i=0; i<l_qty; i++)
                {
					fread(&p_object->polygon[i].a, sizeof(unsigned short), 1, l_file);
					fread (&p_object->polygon[i].b, sizeof (unsigned short), 1, l_file);
					fread (&p_object->polygon[i].c, sizeof (unsigned short), 1, l_file);
					fread (&l_face_flags, sizeof (unsigned short), 1, l_file);
				}
                break;
			case 0x4140:
				fread (&l_qty, sizeof (unsigned short), 1, l_file);
				for (i=0; i<l_qty; i++)
				{
					fread (&p_object->mapcoord[i].u, sizeof (float), 1, l_file);
                    fread (&p_object->mapcoord[i].v, sizeof (float), 1, l_file);
				}
                break;
			default:
				 fseek(l_file, l_chunk_lenght-6, SEEK_CUR);
        }
	}
	fclose (l_file);
	return (1);
}

void dibujar3DS(obj_type o, bool texturado, float X, float Y, float Z){
	glPushMatrix();
	glTranslatef(X,Y,Z);
	glRotatef(90.0,-1.0,0.0,0.0);
    glBindTexture(GL_TEXTURE_2D, o.id_texture);
    int i;
    glBegin(GL_TRIANGLES);
        for (i=0;i<o.polygons_qty;i++) {
            glTexCoord2f( o.mapcoord[o.polygon[i].a].u,
                          o.mapcoord[o.polygon[i].a].v);
            glVertex3f( o.vertex[o.polygon[i].a].x/250,
                        o.vertex[o.polygon[i].a].y/250,
                        o.vertex[o.polygon[i].a].z/250);

            glTexCoord2f( o.mapcoord[o.polygon[i].b].u,
                          o.mapcoord[o.polygon[i].b].v);
            glVertex3f( o.vertex[o.polygon[i].b].x/250,
                        o.vertex[o.polygon[i].b].y/250,
                        o.vertex[o.polygon[i].b].z/250);

            glTexCoord2f( o.mapcoord[o.polygon[i].c].u,
                          o.mapcoord[o.polygon[i].c].v);
            glVertex3f( o.vertex[o.polygon[i].c].x/250,
                        o.vertex[o.polygon[i].c].y/250,
                        o.vertex[o.polygon[i].c].z/250);
        }
    glEnd();
	glPopMatrix();
}
