#include "..\headers\Skybox.h"

Skybox::Skybox()
{
	char* imagenes[6];
	imagenes[0] = img_abajo;
	imagenes[1] = img_adelante;
	imagenes[2] = img_arriba;
	imagenes[3] = img_atras;
	imagenes[4] = img_derecha;
	imagenes[5] = img_izquierda;

	for (int i = 0; i < 6; i++)
	{
		glGenTextures(1, &(texturas[i]));
		SDL_Surface* img = SDL_LoadBMP(imagenes[i]);
		glGenTextures(1, &(texturas[i]));
		glBindTexture(GL_TEXTURE_2D, texturas[i]);
		glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, img->w, img->h, 0, GL_BGR, GL_UNSIGNED_BYTE, img->pixels);
		SDL_FreeSurface(img);
	}
}

void Skybox::draw()
{
	glDisable(GL_DEPTH_TEST);
	//glEnable(GL_TEXTURE_2D);
	
	//back face
	glBindTexture(GL_TEXTURE_2D, texturas[3]);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(size / 2, size / 2, size / 2);
		glTexCoord2f(1, 0);
		glVertex3f(-size / 2, size / 2, size / 2);
		glTexCoord2f(1, 1);
		glVertex3f(-size / 2, -size / 2, size / 2);
		glTexCoord2f(0, 1);
		glVertex3f(size / 2, -size / 2, size / 2);
	glEnd();
	
	//left face
	glBindTexture(GL_TEXTURE_2D, texturas[5]);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(-size / 2, size / 2, size / 2);
		glTexCoord2f(1, 0);
		glVertex3f(-size / 2, size / 2, -size / 2);
		glTexCoord2f(1, 1);
		glVertex3f(-size / 2, -size / 2, -size / 2);
		glTexCoord2f(0, 1);
		glVertex3f(-size / 2, -size / 2, size / 2);
	glEnd();

	//front face
	glBindTexture(GL_TEXTURE_2D, texturas[1]);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0); 
		glVertex3f(size / 2, size / 2, -size / 2);
		glTexCoord2f(1, 0);
		glVertex3f(-size / 2, size / 2, -size / 2);
		glTexCoord2f(1, 1);
		glVertex3f(-size / 2, -size / 2, -size / 2);
		glTexCoord2f(0, 1);
		glVertex3f(size / 2, -size / 2, -size / 2);
	glEnd();
	
	//right face
	glBindTexture(GL_TEXTURE_2D, texturas[4]);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 0);
		glVertex3f(size / 2, size / 2, -size / 2);
		glTexCoord2f(1, 0);
		glVertex3f(size / 2, size / 2, size / 2);
		glTexCoord2f(1, 1);
		glVertex3f(size / 2, -size / 2, size / 2);
		glTexCoord2f(0, 1);
		glVertex3f(size / 2, -size / 2, -size / 2);
	glEnd();

	//top face
	glBindTexture(GL_TEXTURE_2D, texturas[2]);
	glBegin(GL_QUADS);
		glTexCoord2f(1, 0);
		glVertex3f(size / 2, size / 2, size / 2);
		glTexCoord2f(0, 0);
		glVertex3f(-size / 2, size / 2, size / 2);
		glTexCoord2f(0, 1);
		glVertex3f(-size / 2, size / 2, -size / 2);
		glTexCoord2f(1, 1);
		glVertex3f(size / 2, size / 2, -size / 2);
	glEnd();

	//bottom face
	glBindTexture(GL_TEXTURE_2D, texturas[0]);
	glBegin(GL_QUADS);
		glTexCoord2f(1, 1);
		glVertex3f(size / 2, -size / 2, size / 2);
		glTexCoord2f(0, 1);
		glVertex3f(-size / 2, -size / 2, size / 2);
		glTexCoord2f(0, 0);
		glVertex3f(-size / 2, -size / 2, -size / 2);
		glTexCoord2f(1, 0);
		glVertex3f(size / 2, -size / 2, -size / 2);
	glEnd();

	glEnable(GL_DEPTH_TEST);
}

Skybox::~Skybox()
{
	glDeleteTextures(6, &texturas[0]);
}
